#include "SendFileThread.h"
#include "MySyncObject.h"
#include "SendRecvThread.h"
#include "RingBuff.h"

CSendFileThread::CSendFileThread(CSendRecvThread *pCSendRecvThread)
{
	// p[^L
	m_pCSendRecvThread = pCSendRecvThread;

	// ϐ̏
	m_fIamZombie = FALSE;
	m_pCMySyncObject = new CMySyncObject();
	m_pCMySyncObject->Initialize();
	m_pCRingBuffCmd = new CRingBuff(CMD_BUFF_SIZE);	// t@CMR}hi[p

	m_iSendFileStatus = SEND_FILE_STAT_IDLE;		// t@CM̑J

	m_cRecvFileStartReq = 0;						// t@CMJnv(0:l 1:OK -1:G[)
	m_cRecvFileEndRes = 0;							// t@CMv(0:l 1:OK -1:G[)
	m_dwStart = 0;									// ҂^CAEĝߗvs
	m_fdSrcFile = -1;								// Mt@CfBXNv^
	m_lFileLength = 0;								// Mt@C̒
	m_lTotalSentSize = 0;							// Mς݃oCg
	m_iWaitCount = 0;								// M҂
}


CSendFileThread::~CSendFileThread()
{
	if (m_pCMySyncObject != NULL)
		m_pCMySyncObject->Uninitialize();
	SAFE_DELETE(m_pCMySyncObject)
	SAFE_DELETE(m_pCRingBuffCmd)					// t@CMv/i[p
}

UINT CSendFileThread::DoWork()
{
	int			iRet = 0;

	while (!m_fStopFlag)
	{
		Sleep(5);
		// t@CMJڏԂɉ̎s
		// ɑ΂鏈ƃt@CM̊֐Ŏs܂
		if((iRet = DoSendFileState()) == -1)
			break;
	}
	if (m_fdSrcFile != -1)
		_close(m_fdSrcFile);
	m_fdSrcFile = -1;
	m_pCMySyncObject->Lock();
	m_fIamZombie = TRUE;		// t@CMsŃ]r
	m_pCMySyncObject->UnLock();
	return((iRet != -1) ? 0 : -1);
}

//----------------------------------------------
// function
//		t@CMJڏԂɉs
// parameter
//		Ȃ
// return
//		0:Ȃ 1:s 2:M -1:G[
//----------------------------------------------
int CSendFileThread::DoSendFileState()
{
	int iRet = 0;

	if (AnalyzeCmd() == -1)						// vEȂǂ̉ Ԓl-1̎G[
	{
		iRet = -1;
		goto L_END;
	}
	switch (m_iSendFileStatus)
	{
		case SEND_FILE_STAT_START:				// t@CMJnv҂->M/
			if ((iRet = CheckRecvFileStartReq(TIMEOUT_FOR_RES)) == 1)
			{
				if (m_lFileLength == 0)			// t@CM{Ȃv
					m_iSendFileStatus = SEND_FILE_STAT_IDLE;
				else
					m_iSendFileStatus = SEND_FILE_STAT_ING;
			}
			break;
		case SEND_FILE_STAT_ING:				// M->M/M҂
			if ((iRet = SendFileIng()) == 2)	// M->M҂
			{
				iRet = 1;						// v҂܂ŊƂȂ
				m_dwStart = timeGetTime();
				m_iSendFileStatus = SEND_FILE_STAT_END;
			}
			break;
		case SEND_FILE_STAT_END:				// Mv҂->
			if ((iRet = CheckRecvFileEndRes(TIMEOUT_FOR_RES)) == 1)
				m_iSendFileStatus = SEND_FILE_STAT_IDLE;
			break;
		default:
			break;
	}
L_END:
	if (iRet == -1)
	{
		Locate(1, 11, 1);
		fprintf(stderr, "t@CMG[");
	}
	return(iRet);
}

//----------------------------------------------
// function
//		t@CMJnṽ`FbN
// parameter
//		DWORD	dwTimeOut	[in]^CAEg
// return
//		0:܂ĂȂ 1: -1:s܂̓^CAEg
//----------------------------------------------
int CSendFileThread::CheckRecvFileStartReq(DWORD dwTimeOut)
{
	int		iRet = 0;

	if (GetdwInterval(timeGetTime(), m_dwStart) >= dwTimeOut)	// ^CAEg
	{
		iRet = -1;
		goto L_END;
	}
	if (m_cRecvFileStartReq == -1)				// G[
		iRet = -1;
	else if (m_cRecvFileStartReq == 1)			// 
		iRet = 1;
L_END:
	return(iRet);
}

#define	READ_SIZE	(1024 * 10)			// t@C̓ǂݍݒP(KobƓǂ݂܂)
//----------------------------------------------
// function
//		t@CǂݍŃt@CM/t@CMpPbg𑗐M
//		̊֐ŃG[NƂ́AfR}h𑗂̂ǂł傤
// parameter
//		Ȃ
// retun
//		TRUE/FALSE
//----------------------------------------------
int CSendFileThread::SendFileIng()
{
	BOOL			fEnd = FALSE, fRet;
	LPBYTE			pbData = NULL;
	int				iRet = 0, iReadSize;
	RecvFileIngRec	*pRecvFileIng = NULL;
	int				iPacketSize;

	// t@Cǂݍ
	pbData = (LPBYTE)calloc(READ_SIZE, sizeof(BYTE));
	_lseek(m_fdSrcFile, m_lTotalSentSize, SEEK_SET);
	iReadSize = _read(m_fdSrcFile, pbData, READ_SIZE);
	iPacketSize = sizeof(HeaderRec) + sizeof(SendFileStatRec) + iReadSize;
	pRecvFileIng = (RecvFileIngRec *)calloc(iPacketSize, sizeof(BYTE));

	// ʃwb_Ƀf[^i[
	memcpy(pRecvFileIng->header.bMagicData, MAGIC_STRING, strlen(MAGIC_STRING));
	pRecvFileIng->header.wDataLen = htons((WORD)sizeof(SendFileStatRec) + iReadSize);
	// f[^Ƀf[^i[
	DISABLE_C4996
	sprintf(pRecvFileIng->Stat.szOffset, "%d", m_lTotalSentSize);	// ǂݍ݈ʒu
	sprintf(pRecvFileIng->Stat.szSize, "%d", iReadSize);			// ǂݍ񂾃f[^
	ENABLE_C4996
	if (iReadSize > 0)				// t@C̓r𑗐M
	{
		Locate(1, 12, 1);
		fprintf(stderr, "t@CM %d %d %d", m_lTotalSentSize, iReadSize, m_lFileLength);
		// ʃwb_Ƀf[^i[
		pRecvFileIng->header.wCommand = htons(CMD_RECV_FILE_ING);
		// f[^Ƀf[^i[
		memcpy(pRecvFileIng->bData, pbData, iReadSize);
	}
	else							// t@C̍Ō܂œǂ񂾂̂Ŋ𑗐M
	{
		Locate(1, 13, 1);
		fprintf(stderr, "t@CM %d %d", m_lTotalSentSize, iReadSize);
		// ʃwb_Ƀf[^i[
		pRecvFileIng->header.wCommand = htons(CMD_RECV_FILE_END_REQ);
		fEnd = TRUE;				// t@CM
	}
	// pPbgŜ𑗐Mobt@ɏ
	fRet = m_pCSendRecvThread->SetSendData((char *)pRecvFileIng, iPacketSize);
	if (fRet == TRUE)				// pPbg߂
	{
		if (fEnd == TRUE)			// Ō܂őM̂ŏI
		{
			_close(m_fdSrcFile);
			m_fdSrcFile = -1;
			iRet = 2;
		}
		else
		{
			m_lTotalSentSize += iReadSize;	// pPbg߂̂œǂݍ݃|C^XV
			iRet = 1;
		}
	}
	else							// ߂Ȃ̂œǂݍ݃|C^͂̂܂
	{
		Locate(1, 14, 0);
		fprintf(stderr, "Mobt@̋󂫑҂(%d)", ++m_iWaitCount);
		// Mobt@ɏȂ̂łƑ҂
		Sleep(100);					// READ_SIZE𑗐M̂Ɋ|鎞Ԓx҂̂ǂł傤
	}
	SAFE_FREE(pRecvFileIng)
	SAFE_FREE(pbData)
	return(iRet);
}

//----------------------------------------------
// function
//		t@CMJṽ`FbN
// parameter
//		DWORD	dwTimeOut	[in]^CAEg
// return
//		0:܂ĂȂ 1: -1:s܂̓^CAEg
//----------------------------------------------
int CSendFileThread::CheckRecvFileEndRes(DWORD dwTimeOut)
{
	int		iRet = 0;

	if (GetdwInterval(timeGetTime(), m_dwStart) >= dwTimeOut)	// ^CAEg
	{
		iRet = -1;
		goto L_END;
	}
	if (m_cRecvFileEndRes == -1)				// G[
		iRet = -1;
	else if (m_cRecvFileEndRes == 1)			// 
		iRet = 1;
L_END:
	return(iRet);
}

//----------------------------------------------
// function
//		t@CMR}h/̉
// parameter
//		Ȃ
// retun
//		0:\ȃf[^i[ĂȂȂ 1:͐ -1:͎s
//----------------------------------------------
int CSendFileThread::AnalyzeCmd()
{
	int			iRet = 0;
	HeaderRec	Header;
	WORD		wCmd;
	int			iSize = m_pCRingBuffCmd->GetReadableSize();
	int			iPacketSize, iDataSize;
	LPBYTE		pbPacket = NULL;

	if (iSize < sizeof(HeaderRec))			// wb_TCYɖȂƂ͉Ȃ
		goto L_END;

	// wb_؂ǂݍ݂(pPbgۂƊi[Ă͂)
	m_pCRingBuffCmd->ReadWithoutUpdateHeadPoint((LPBYTE)&Header, sizeof(HeaderRec));
	wCmd = ntohs(Header.wCommand);
	iDataSize = ntohs(Header.wDataLen);
	iPacketSize = iDataSize + sizeof(HeaderRec);
	if (iSize < iPacketSize)				// pPbgTCYɖȂƂ͉Ȃ
		goto L_END;

	pbPacket = (LPBYTE)calloc(iPacketSize, sizeof(BYTE));
	// pPbgŜǂ
	m_pCRingBuffCmd->Read(pbPacket, iPacketSize);
	switch (wCmd)
	{
		case CMD_RECV_FILE_SIZE_REQ:			// MTCYv
			if ((iRet = RecvRecvFileSizeReqPacket((RecvFileSizeReqRec *)pbPacket)) == 1)
			{
				m_dwStart = timeGetTime();
				m_iSendFileStatus = SEND_FILE_STAT_START;
			}
			break;
		case CMD_RECV_FILE_START_REQ:			// MJnv
			iRet = RecvRecvFileStartReqPacket((RecvFileStartReqRec *)pbPacket);
			break;
		case CMD_RECV_FILE_END_RES:				// Mvɑ΂鉞
			iRet = RecvRecvFileEndResPacket((RecvFileResRec *)pbPacket);
			break;
		case CMD_RECV_FILE_ABORT_REQ:			// fv
			iRet = RecvRecvFileAbortReqPacket((RecvFileAbortReqRec *)pbPacket);
			break;
		default:
			iRet = -1;
			break;
	}
L_END:
	SAFE_FREE(pbPacket)
	return(iRet);
}

//----------------------------------------------
// function
//		t@CTCYvR}h̉
//		t@C̃I[v
//		̑M(I[vs̓TCYڂ0ŉ
// parameter
//		Ȃ
// retun
//		0:\ȃf[^i[ĂȂȂ 1:͐ -1:͎s 2:Mt@CȂ
//----------------------------------------------
int CSendFileThread::RecvRecvFileSizeReqPacket(RecvFileSizeReqRec *pbPacket)
{
	int			iRet = 1;
	struct stat statInfo;			// t@C̏̂߂̕ϐ
	int			iSize;
	LPBYTE		pbDest = NULL;

	if (m_iSendFileStatus != SEND_FILE_STAT_IDLE)
	{
		iRet = -1;						// JڏԃG[͐ؒf
		goto L_END;
	}
	m_cRecvFileStartReq = 0;						// t@CMJnv(0:l 1:OK -1:G[)
	m_cRecvFileEndRes = 0;							// t@CMv(0:l 1:OK -1:G[)
	m_lFileLength = 0;								// Mt@C̒
	m_lTotalSentSize = 0;							// Mς݃oCg
	m_iWaitCount = 0;								// M҂

	// UTF-8ŎM̂ŁASJISɕϊopen
	ConvUtf8toSJis((LPBYTE)pbPacket->FileInfo.szFileName, NULL, &iSize);
	pbDest = (LPBYTE)calloc(iSize, sizeof(BYTE));
	ConvUtf8toSJis((LPBYTE)pbPacket->FileInfo.szFileName, pbDest, &iSize);

	// œǂݍݗpɃt@Copen
	DISABLE_C4996
	m_fdSrcFile = _open((LPSTR)pbDest, _O_RDONLY | _O_BINARY);
	ENABLE_C4996
	if (m_fdSrcFile == -1)
	{
		iRet = 2;
		Locate(1, 11, 2);
		fprintf(stderr, "Mt@C݂Ȃ %s", pbDest);
		if (SendRecvFileSizeResPacket(pbPacket->FileInfo.szFileName, 0) == FALSE)			// t@CTCY0ŉ
			iRet = -1;
		goto L_END;
	}
	// t@C̏擾(t@CTCY)
	if (fstat(m_fdSrcFile, &statInfo) != 0)
		goto L_END;
	m_lFileLength = statInfo.st_size;
	if (SendRecvFileSizeResPacket(pbPacket->FileInfo.szFileName, m_lFileLength) == FALSE)	// 
		iRet = -1;

L_END:
	SAFE_FREE(pbDest)
	return(iRet);
}


//----------------------------------------------
// function
//		t@CTCYvM
// parameter
//		LPSTR	pszFileName	[in]t@C
//		long	lFileLength	[in]t@C
// retun
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendFileThread::SendRecvFileSizeResPacket(LPSTR pszFileName, long lFileLength)
{
	BOOL		fRet = FALSE;
	RecvFileSizeResRec	*pRecvFileSizeRes = NULL;
	int			iPacketSize;
	int			iSize;
	LPBYTE		pbDest = NULL;

	// ʃwb_Ƀf[^i[
	iPacketSize = sizeof(RecvFileSizeResRec);
	pRecvFileSizeRes = (RecvFileSizeResRec *)calloc(iPacketSize, sizeof(BYTE));
	memcpy(pRecvFileSizeRes->header.bMagicData, MAGIC_STRING, strlen(MAGIC_STRING));
	pRecvFileSizeRes->header.wCommand = htons(CMD_RECV_FILE_SIZE_RES);
	pRecvFileSizeRes->header.wDataLen = htons(sizeof(FileInfoRec));

	// UTF-8ŎM̂ŁASJISɕϊĕ\
	ConvUtf8toSJis((LPBYTE)pszFileName, NULL, &iSize);
	pbDest = (LPBYTE)calloc(iSize, sizeof(BYTE));
	ConvUtf8toSJis((LPBYTE)pszFileName, pbDest, &iSize);

	Locate(1, 11, 2);
	fprintf(stderr, "t@CM %s %d", pbDest, lFileLength);
	// f[^Ƀf[^i[(t@CTCYAt@C)
	DISABLE_C4996
	sprintf(pRecvFileSizeRes->FileInfo.szFileName, "%s", pszFileName);
	sprintf(pRecvFileSizeRes->FileInfo.szFileSize, "%d", lFileLength);
	ENABLE_C4996

	// t@CTCYvpPbg̑M
	fRet = m_pCSendRecvThread->SetSendData((char *)pRecvFileSizeRes, iPacketSize);

	SAFE_FREE(pbDest)
	SAFE_FREE(pRecvFileSizeRes);
	return(fRet);
}

//----------------------------------------------
// function
//		t@CMJnvM
//		TCY0̎̓t@CMsȂ̂ŃN[Y
// parameter
//		Ȃ
// retun
//		0:\ȃf[^i[ĂȂȂ 1:͐ -1:͎s
//----------------------------------------------
int CSendFileThread::RecvRecvFileStartReqPacket(RecvFileStartReqRec *pbPacket)
{
	int			iRet = 1;

	if (m_iSendFileStatus != SEND_FILE_STAT_START)
	{
		iRet = -1;						// JڏԃG[͐ؒf
		goto L_END;
	}
	m_cRecvFileStartReq = 1;
	if(atol(pbPacket->FileInfo.szFileSize) == 0)
		m_lFileLength = 0;
	if (m_lFileLength == 0)
		_close(m_fdSrcFile);

L_END:
	return(iRet);
}

//----------------------------------------------
// function
//		t@CMv
// parameter
//		SendFileResRec *pbPacket	[in]MpPbg
// return
//		TRUE/FALSE
//----------------------------------------------
int CSendFileThread::RecvRecvFileEndResPacket(SendFileResRec *pbPacket)
{
	int			iRet = 1;

	m_cRecvFileEndRes = pbPacket->cResCode;
	return(iRet);
}

//----------------------------------------------
// function
//		t@CMfR}h̎M
// parameter
//		 RecvFileAbortReqRec *pbPacket 	[in]t@CMfR}hpPbg
// return
//		0:\ȃf[^i[ĂȂ 1:͐ -1:͎s
//----------------------------------------------
int CSendFileThread::RecvRecvFileAbortReqPacket(RecvFileAbortReqRec *pbPacket)
{
	int			iRet = 0;

	m_iSendFileStatus = SEND_FILE_STAT_ABORT;
	Locate(1, 13, 1);
	fprintf(stderr, "t@CMf");

	iRet = 1;
	SendRecvFileAbortResPacket(1);		// MfvM

	if (m_fdSrcFile != -1)
		_close(m_fdSrcFile);
	m_fdSrcFile = -1;
	m_iSendFileStatus = SEND_FILE_STAT_IDLE;
	return(iRet);
}

//----------------------------------------------
// function
//		t@CMfvɑ΂鉞𑗐M
// parameter
//		char cResCode	[in]R[h 1/-1
// return
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendFileThread::SendRecvFileAbortResPacket(char cResCode)
{
	BOOL	fRet = FALSE;
	RecvFileResRec	*pRecvFileAbortRes = NULL;
	int		iPacketSize;

	iPacketSize = sizeof(RecvFileResRec);
	pRecvFileAbortRes = (RecvFileResRec *)calloc(iPacketSize, sizeof(BYTE));
	memcpy(pRecvFileAbortRes->header.bMagicData, MAGIC_STRING, strlen(MAGIC_STRING));
	pRecvFileAbortRes->header.wCommand = htons(CMD_RECV_FILE_ABORT_RES);
	pRecvFileAbortRes->header.wDataLen = htons(sizeof(char));
	pRecvFileAbortRes->cResCode = cResCode;

	fRet = m_pCSendRecvThread->SetSendData((char *)pRecvFileAbortRes, iPacketSize);
	SAFE_FREE(pRecvFileAbortRes)

	return(fRet);
}

//----------------------------------------------
// function
//    ̃Xbh̓]rԂ
//	  ʃXbhQƂ
// parameter
//    Ȃ
// return
//    0: -1:G[
//----------------------------------------------
BOOL CSendFileThread::IsZombie()
{
	BOOL	fRet;

	m_pCMySyncObject->Lock();
	fRet = m_fIamZombie;
	m_pCMySyncObject->UnLock();
	return(fRet);
}
